package bitel.billing.test.convert;

import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import bitel.billing.common.CommonTimeUtils;
import bitel.billing.common.IPUtils;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.ipn.bean.AddressRange;
import bitel.billing.server.ipn.bean.AddressRangeManager;
import bitel.billing.server.ipn.bean.RangeIface;
import bitel.billing.server.ipn.bean.RangeIfaceManager;
import bitel.billing.server.ipn.bean.UserGateRule;
import bitel.billing.server.ipn.bean.UserGateRuleManager;
import bitel.billing.server.util.DefaultServerSetup;
import bitel.billing.server.util.SetupData;
import bitel.billing.server.util.Utils;

public class Dalnegorsk
{	
	
	private static DefaultServerSetup sourceSetup = new DefaultServerSetup();
	//private static DefaultServerSetup dstSetup = new DefaultServerSetup();
	private static SetupData dstSetup = new SetupData("data.data");
	
	private static final int GROUP  = 1;
	private static final int PHYS_PATTERN = 3;
	private static final int UR_PATTERN = 4;
	private static final int GROUP_PATTERN = 4;
	
	
	private static final int IPN_MID = 2;
	
	
	private static final int PARAM_FIO_ID = 1;
	private static final int PARAM_PASSPORT_NUM = 2;
	private static final int PARAM_TELEPHONE = 3;
	private static final int PARAM_INN = 4;
	private static final int PARAM_KPP = 5;
	private static final int PARAM_BIK = 6;
	private static final int PARAM_KOR_CHET = 7;
	private static final int PARAM_BANK_NAME = 8;
	private static final int PARAM_RAS_CHET = 9;
	private static final int PARAM_DIRECTOR = 10;
	private static final int PARAM_ACCOUNTANT = 11;
	private static final int PARAM_PASPORT_PLACE = 12;
	private static final int PARAM_PASPORT_DATE = 13;
	
	private static final int TARIFF_UNDEF = 47;
		
	
	

	
	/**
	 * @param args
	 * @throws SQLException 
	 * @throws UnsupportedEncodingException 
	 */
	
	private static Map<Integer, Map > getUsers() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from users";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map user = new HashMap();
				int id = rs.getInt( "id" ) ;
				user.put( "id", id );
				
				
				
				
				user.put( "name", getString( rs, "name" ) );				
				user.put( "username", getString( rs, "username" ) );
				user.put( "password", getString( rs, "password" ) );
				user.put( "usergroup", rs.getInt ( "usergroup" ) );
				user.put( "category", rs.getInt( "category" ) );
				user.put( "usertype", rs.getInt( "usertype" ) );
				user.put( "state", rs.getBoolean( "state" ) );
				user.put( "schet", rs.getInt( "schet" ) );
				
				
				users.put( id, user );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;
		
	}
	
	private static Map<Integer, Map > getGroups() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > groups = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from groups WHERE id in (	5,6,7,9,10,16,17,18,19,21,22,23) ";																
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map user = new HashMap();
				int id = rs.getInt( "id" ) ;
				user.put( "id", id );
				
				
				user.put( "name", getString( rs, "name" ) );				
				user.put( "balans", rs.getBigDecimal( "balans" ) );
				
				groups.put( id, user );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return groups;
		
	}
	

	private static String getString( ResultSet rs, String field )	throws SQLException,
													UnsupportedEncodingException
	{
		byte bytes [] = rs.getBytes( field );
		
		String pp = bytes != null ?  new String( bytes, "koi8-r" ) : null;
		return pp;
	}
	
	private static Map<Integer, Map > readUserData() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from user_data";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map user = new HashMap();
				
				int userId = rs.getInt( "user_id" ) ;
				user.put( "userId", userId );
				user.put( "dogovor", rs.getInt( "dogovor" ) );				
				user.put( "dog_start", rs.getDate( "dog_start" ) );
				user.put( "dog_end", rs.getDate( "dog_end" ) );
				user.put( "mesto_pass", getString( rs, "mesto_pass" ) );
				user.put( "date_pass", rs.getDate( "date_pass" ) );
				
				users.put( userId, user );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}
	 
	private static Map<Integer, Map > readTarifs() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from tarifs";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map tarif = new HashMap();
				
				int id = rs.getInt( "id" ) ;
				tarif.put( "id", id );				
				tarif.put( "name",  getString( rs, "name" ) );				
				
				users.put( id, tarif );				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}
	
	private  static Map<String, Integer >  getBillingTariffMap( )
	{
		Map<String, Integer > tarifMap = new HashMap<String, Integer>();
		Connection con = null;
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			String query = "SELECT id, title FROM tariff_plan";
			
			 
			
			PreparedStatement ps =  con.prepareStatement(   query );            
			ResultSet rs = ps.executeQuery();
			while ( rs.next() )
			{
				tarifMap.put( rs.getString( 2 ), rs.getInt( 1 )  );
				
			}
			rs.close();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}
		
		
		
		return tarifMap; 
	}
		
	
	private static Map<Integer, List > readTariffUserData() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, List > users = new HashMap<Integer, List>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from user_tarifs";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				int userId = rs.getInt( "user_id" ) ;
				List tariff  = users.get( userId ); 
				if ( tariff == null)
				{
					tariff = new ArrayList();
					users.put( userId , tariff);
				}
				
				Map map = new HashMap();
				map.put( "tarif_id",  rs.getInt( "tarif_id" ) );
				map.put( "date_start", rs.getDate( "date_start" ) );
				map.put( "date_end", rs.getDate( "date_end" ) );
				
				
				tariff.add( map );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}	
	
	
	private static Map<Integer, Map > readOrgData() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from user_org_data";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map user = new HashMap();
				int userId = rs.getInt( "user_id" ) ;
				user.put( "userId", userId );
				user.put( "tel", getString( rs, "tel" ) );				
				user.put( "inn", getString( rs, "inn" ) );
				user.put( "kpp", getString( rs, "kpp" ) );
				user.put( "bik", getString( rs, "bik" ) );
				user.put( "kor", getString( rs, "kor" ) );
				user.put( "bank", getString( rs, "bank" ) );
				user.put( "rs", getString( rs, "rs" ) );
				user.put( "director", getString( rs, "director" ) );
				user.put( "buhgalter", getString( rs, "buhgalter" ) );
				
								
				users.put( userId, user );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}	
	
	
	private static Map<Integer, List > readIpUserData() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, List > users = new HashMap<Integer, List>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from users_ip";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				int userId = rs.getInt( "user_id" ) ;
				
				List ips  = users.get( userId ); 
				if ( ips == null)
				{
					ips = new ArrayList();
					users.put( userId , ips);
					
				}
				
				Map map = new HashMap();
				map.put( "ip_address",  rs.getString( "ip_address" ));				
				map.put( "time_on", rs.getDate( "time_on" ) );
				map.put( "time_off", rs.getDate( "time_off" ) );
				
				
				ips.add( map );				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}		
	
	private static Map<Integer, Map > readBalans() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
			con = sourceSetup.getDBConnectionFromPool();
			
			String query = " Select * from balans";    		
			ResultSet rs = con.createStatement().executeQuery( query );
			while ( rs.next() )
			{
				Map user = new HashMap();
				int userId = rs.getInt( "user_id" ) ;
				user.put( "user_id", userId );
				user.put( "balans", rs.getBigDecimal( "balans" ) );												
				users.put( userId, user );
				
			}
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;		
	}		
	
	
	private static boolean readBoolean(Map line, String name)
	{
		Boolean result = (Boolean) line.get( name );
		return result == null ? false :  result;
	}
	
	private static Date readDate(Map line, String name)
	{
		Date result = (Date) line.get( name );
		return result;
	}
	
	private static String readString(Map line, String name)
	{
		String result = (String) line.get( name );
		return result;
	}
	
	private static int readInt(Map line, String name, int defaultValue)
	{
		int result = line.get( name ) != null ? ( Integer ) line.get( name ) : defaultValue;  
		return result;
	}	
	
	private static long readLong(Map line, String name, int defaultValue)
	{
		long result = line.get( name ) != null ? ( Long ) line.get( name ) : defaultValue;  
		return result;
	}	
	
	private static double readDouble(Map line, String name)
	{
		double result = (Double) line.get( name );
		return result;
	}		
	
	private static BigDecimal readBigDecimal(Map line, String name)
	{
		BigDecimal result = (BigDecimal) line.get( name );
		return result;
	}		
	
	
	
	private static List<Contract> createGroups(Map<Integer, Map> groups)
	{

		List<Contract> result = new ArrayList<Contract>();
		Connection con = null;
		Date currDate = new Date();
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			ContractManager manager =  new ContractManager( con );
			
			System.out.println( groups.size() + " groups was found..");		
			
			int idx = 0;
			for (Map.Entry<Integer, Map> entry : groups.entrySet())
	    	{
	    		int id = entry.getKey();
	    		Map line = entry.getValue();
	    		
	    		
	    		Date date = new Date();

	    		
	    		
	    		String title = "G000" + String.valueOf( id );
	    		   		
	    		
	    		
	    		
	    		int pattern =  GROUP_PATTERN;
	    			    		
	    		
	    		Contract contract = manager.createFromPattern( pattern, title, CommonTimeUtils.convertDateToCalendar( date ), "");
	    		
	    		if (contract != null)
	    		{	
	    			int cid = contract.getID();
	    			
	    			line.put( "position", idx++ );
	    			
	    			result.add( contract );	   
	    			
					updateGroupInfo( cid, line ); 
					updateGroupBalance( contract, con, cid, line, currDate );
	    		}
	    		
	    		
	    		        		
	    	}			
			
			System.out.println( result.size() + " groups was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}		
		
		return result;
	}
		
	private static void addUsersToGroups( Map<Integer, Map> users, Map<Integer, Map> groups, List<Contract> contacts, List<Contract> groupContacts )
	{
		Connection con = null;
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			System.out.println( "adding groups!!! " );
					
			for (Map.Entry<Integer, Map> entry : users.entrySet())
			{
				Map line = entry.getValue();
				int group = readInt( line, "usergroup", -1 );
				if ( group < 0) 
				{
					continue;
				}
				
				int idx1 = readInt( line, "position", -1 );
				Contract subContract =  contacts.get( idx1 );
				
				Map groupLine = groups.get( group );
				if ( groupLine == null )
				{
					//System.out.println( "error : where is no group " +  group);
					continue;
				}
				
				int idx2 = readInt( groupLine, "position", -1 );
				Contract superContract =  groupContacts.get( idx2 );
				
				System.out.println( "super =  " + superContract.getID() + ";sub=" +  subContract.getID() );
				
				new ContractManager( con ).addSub( superContract.getID(), subContract.getID() );
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );		
		}
	}
	
	
	private static List<Contract> createContacts(Map<Integer, Map> users)
	{

		List<Contract> result = new ArrayList<Contract>();
		Connection con = null;
		Date currDate = new Date();
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			
			int idx = 0;
			System.out.println( users.size() + " contacts was found..");			
			for (Map.Entry<Integer, Map> entry : users.entrySet())
	    	{
	    		int uid = entry.getKey();
	    		Map line = entry.getValue();
	    		
	    		
	    		Date date = readDate( line, "dog_start" );

	    		
	    		
	    		ContractManager manager =  new ContractManager( con );
	    		
	    		String title = String.valueOf( readInt(line, "schet", -1 ) );
	    		String pswd =  readString(line, "password" );   		
	    		
	    		int category = readInt( line, "category", -1 );
	    		
	    		int pattern =  0;
	    		
	    		switch ( category )
	    		{
	    			case 1: case 3: case 4: case 6 : pattern = PHYS_PATTERN; break; 
	    			case 7: case 5: case 8:  pattern = UR_PATTERN; break;
	    		}
	    		
	    		Contract contract = manager.createFromPattern( pattern, title, CommonTimeUtils.convertDateToCalendar( date ), pswd);
	    		
	    		if (contract != null)
	    		{	
	    			int cid = contract.getID();
	    			result.add( contract );
	    			
	    			line.put( "position", idx++ );
	    			line.put( "cid", cid );
	    			
	    			updateContactInfo(  contract.getID(), line);
	    			updateContactParams( contract, con, cid, line );
	    			updateContactBalance( contract, con, cid, line, currDate );
	    		}
	    		
	    		
	    		        		
	    	}			
			
			System.out.println( result.size() + " contacts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}		
		
		return result;
	}
	
	
	private static void updateContactInfo(	int cid,											
											Map line)
	{
		
		Connection con = null;
		
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,  " +
						" date2 = ?, " +
						" comment = ? " +
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP );
			ps.setDate( idx++, CommonTimeUtils.convertDateToSqlDate( readDate( line, "dog_end" ) ) );
			ps.setString( idx++, readString( line, "name" ) );
			//ps.setDouble ( idx++, readDouble( line, "credit" ) );							
			//ps.setString( idx++, readString( line, "fio" ) );			
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}
			
	}	
	
	private static void updateGroupInfo(	int cid,											
											Map line)
	{
		
		Connection con = null;
		
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,  " +						
						" comment = ? " +
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP );			
			ps.setString( idx++, readString( line, "name" ) );
			//ps.setDouble ( idx++, readDouble( line, "credit" ) );							
			//ps.setString( idx++, readString( line, "fio" ) );			
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}
			
	}		
	
	private static void updateContactParams(	Contract contract,
												Connection con,
												int cid,
												Map line)
	{
		
		
		addContactParamString(contract, con, cid, readString( line, "name" ), PARAM_FIO_ID);
		addContactParamString(contract, con, cid, readString( line, "pasport" ), PARAM_PASSPORT_NUM);
		addContactParamString(contract, con, cid, readString( line, "mesto_pass" ), PARAM_PASPORT_PLACE);
		addContactParamDate(contract, con, cid, readDate( line, "date_pass" ), PARAM_PASPORT_DATE);
		
		addContactParamString(contract, con, cid, readString( line, "tel" ), PARAM_TELEPHONE);
		addContactParamString(contract, con, cid, readString( line, "inn" ), PARAM_INN);
		addContactParamString(contract, con, cid, readString( line, "kpp" ), PARAM_KPP);
		addContactParamString(contract, con, cid, readString( line, "bik" ), PARAM_BIK);
		addContactParamString(contract, con, cid, readString( line, "kor" ), PARAM_KOR_CHET);
		addContactParamString(contract, con, cid, readString( line, "bank" ), PARAM_BANK_NAME);
		addContactParamString(contract, con, cid, readString( line, "rs" ), PARAM_RAS_CHET);
		addContactParamString(contract, con, cid, readString( line, "director" ), PARAM_DIRECTOR);
		addContactParamString(contract, con, cid, readString( line, "buhgalter" ), PARAM_ACCOUNTANT);
		
		
		
	}
	
	private static void addContactParamString( Contract contract, Connection con, int cid, String value, int pid )
	{
		
		try
		{
			
			String query = "DELETE FROM contract_parameter_type_1 WHERE cid=? AND pid=?";
			PreparedStatement ps =  con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.executeUpdate();

			if ( !Utils.isEmptyString( value ) )
			{
				query = "INSERT INTO contract_parameter_type_1 " +
						"( cid, pid, val ) VALUES ( ?, ?, ? )";
				ps = con.prepareStatement( query );
				ps.setInt( 1, cid );
				ps.setInt( 2, pid );
				ps.setString( 3, value );
				ps.executeUpdate();
			}			
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
				
		
	}	
	
	private static void addContactParamDate(	Contract contract,
	                                        	Connection con,
												int cid,
												Date value,
												int pid )
	{		
		try
		{			
			String query = "DELETE FROM contract_parameter_type_6 WHERE cid=? AND pid=?";
			PreparedStatement ps =  con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.executeUpdate();

			if( value != null )
			{
				query = "INSERT INTO contract_parameter_type_6 " +
						"( cid, pid, val ) VALUES ( ?, ?, ? )";
				ps = con.prepareStatement( query );
				ps.setInt( 1, cid );
				ps.setInt( 2, pid );
				ps.setDate( 3, CommonTimeUtils.convertDateToSQL( value ) );
				ps.executeUpdate();
			}

			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
						
		
	}	
	
	
	private static void updateContactBalance(	Contract contract,
	                                         	Connection con,
												int cid,												
												Map line,
												Date currDate)
	{
		
		Calendar cal = new GregorianCalendar();
		cal.setTime( currDate );
		
		BigDecimal balance = readBigDecimal( line, "balans");
		if (balance != null)
		{
			int year = cal.get( Calendar.YEAR );
			int month = cal.get( Calendar.MONTH  ) + 1;
			try
			{			
				String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
				PreparedStatement ps =  con.prepareStatement( query );
				int idx = 1;
				ps.setInt( idx++, year );
				ps.setInt( idx++, month );
				ps.setInt( idx++, cid );			 
				ps.setDouble( idx++, balance.doubleValue() );
				
				ps.executeUpdate();
				
				
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
			finally
			{			
			}		
		}
	}	
	
	
	private static void updateGroupBalance(	Contract contract,
	                                         	Connection con,
												int cid,												
												Map line,
												Date currDate)
	{
		
		Calendar cal = new GregorianCalendar();
		cal.setTime( currDate );
		
		BigDecimal balance = readBigDecimal( line, "balans");
		if (balance != null)
		{
			int year = cal.get( Calendar.YEAR );
			int month = cal.get( Calendar.MONTH  ) + 1;
			try
			{			
				String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
				PreparedStatement ps =  con.prepareStatement( query );
				int idx = 1;
				ps.setInt( idx++, year );
				ps.setInt( idx++, month );
				ps.setInt( idx++, cid );			 
				ps.setDouble( idx++, balance.doubleValue() );
				
				ps.executeUpdate();
				
				
			}
			catch (Exception ex)
			{
				ex.printStackTrace();
			}
			finally
			{			
			}		
		}
	}	
		
	private static void updateSubContracts(	Map<Integer, Map > users)
	{
		Connection con = null;
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			ContractManager manager = new ContractManager( con );
			
			
						
		}
		finally
		{			
			dstSetup.returnConToPool( con );
		}		
		
	}	
	
	private static void addTariffInfo( Map<Integer, Map > users, Map<Integer, List > tariffData ) throws UnsupportedEncodingException, SQLException
	{
		Map<Integer, Map > origTarifs = readTarifs();
		
		Map<String, Integer >  billTariffs = getBillingTariffMap( );
		
		Connection con = null;
		
		try
		{
			con = dstSetup.getDBConnectionFromPool();
		
			String query = "INSERT INTO contract_tariff( cid, tpid, date1, date2) VALUES ( ?, ?, ?, ?)";
		    PreparedStatement ps =  con.prepareStatement(   query );
		    			
		
			for (Map.Entry<Integer, Map> entry : users.entrySet())
			{
				Map line = entry.getValue();
				int cid =  readInt( line, "cid", -1 );
				
				int uid = entry.getKey();
				
				List< Map > tarifs = tariffData.get( uid );
				if ( tarifs == null )
				{
					continue;
				}
				
				for ( Map tarifMap : tarifs )
				{
										
					int tariffId = (Integer) tarifMap.get( "tarif_id" );
					Date startDate = (Date) tarifMap.get( "date_start");
					Date endDate = (Date) tarifMap.get("date_end");
					
					
					
					Map tariffLine = origTarifs.get( tariffId );
					
					String tarifName = readString( tariffLine, "name" );
					
					Integer billTariffId = billTariffs.get( tarifName );
					if ( billTariffId  == null )
					{
						System.out.println( "    BGBilling  " + tarifName );
						billTariffId = TARIFF_UNDEF; 
						//continue;
					}
					
					int idx = 1;
				    ps.setInt( idx++, cid );
		    		ps.setInt( idx++,  billTariffId);
		    		ps.setDate( idx++, CommonTimeUtils.convertDateToSqlDate( startDate ) );
		    		ps.setDate( idx++, CommonTimeUtils.convertDateToSqlDate( endDate ) );
		    		
		    		
		    		ps.executeUpdate();
				}
		    		
			}
				
		}
		finally
		{
			dstSetup.returnConToPool( con );	
		}
	}
		
	
	

	private static void combineMaps(	Map<Integer, Map> parentMap,
										Map<Integer, Map> childMap )
	{
		for (Integer uid  : parentMap.keySet())
		{
			Map<String, Object> parentValues  =  parentMap.get(  uid );
			Map<String, Object> otherValues  =  childMap.get(  uid );
			
			
			if (otherValues != null)
			{
		    	for (Map.Entry<String, Object> entry : otherValues.entrySet())
		    	{
		    		parentValues.put( entry.getKey(), entry.getValue() );	
		    	}
			}
			else
			{
				parentValues.put( "noAddress", true ); 
			}
			
			
			
			
		}
	}
	
	private static void addIpData( Map<Integer, Map > users, Map<Integer, List > ipData ) throws SQLException
	{
		Connection con = null;
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			
			for (Map.Entry<Integer, Map> entry : users.entrySet())
			{
				int uid = entry.getKey();
				Map line = entry.getValue();
				int cid =  readInt( line, "cid", -1 );
				
				
				List < Map> ips = ipData.get( uid );
				if ( ips == null)
				{
					continue;
				}
				
				for ( Map m : ips)
				{
					
					String ipStr = (String) m.get( "ip_address" );
					long ip = IPUtils.convertStringIPtoLong ( ipStr , -1);
					
					
					if ( ip == -1 )
					{
						
						System.out.println("wrong ip addess:" + ipStr + "!!");
						continue;		
					}
					
				
					
					Date timeOn = (Date) m.get( "time_on");
					Date timeOff = (Date) m.get( "time_off");
					
			        
			        
			        AddressRange address = new AddressRange();
			        AddressRange oldAddress = null;
			        
			        address.setAddr1(  ip );
			        address.setAddr2( ip );
			        address.setPort1( 0 );
			        address.setPort2( 65535 );
			        address.setDate1( CommonTimeUtils.convertDateToCalendar( timeOn ) );
			        address.setDate2( CommonTimeUtils.convertDateToCalendar( timeOff ) );
			        address.setPlanId( 0 );
			        address.setComment( "    " );
			        address.setContractID( cid );
			        
			        
			        
			        //   
			        List<RangeIface> ifaceList = new ArrayList<RangeIface>();
			        RangeIface rangeIface = new RangeIface();
			        rangeIface.setRangeId( address.getID() );
			        rangeIface.setSourceId( 1 );
			        rangeIface.setIfaceId( -1 );
			        
			        ifaceList.add( rangeIface );
			        
		
			        AddressRangeManager manager = new AddressRangeManager( con, IPN_MID );
			        RangeIfaceManager rangeIfaceManager = new RangeIfaceManager(  con, IPN_MID );
			        
			        manager.updateAddressRangeInfo( "new", address );
			        rangeIfaceManager.updateAddressRangeIfaces( address.getID(), ifaceList );
		
				
			        String query = "INSERT INTO ip_resource_use_" + IPN_MID + "(resource_id, date1,  cid) VALUES(?, ?, ?)";
					PreparedStatement ps =  con.prepareStatement( query );
					int idx = 1;
					ps.setInt( idx++, 1 );
					ps.setDate( idx++, CommonTimeUtils.convertDateToSqlDate(  new Date()  ));
					ps.setInt( idx++, cid );			 			
					
					ps.executeUpdate();
				}
			}
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}
		
					
		
	}
	
	
	private static void addGateData( List <Contract> contracts ) throws SQLException
	{
		Connection con = null;
		try
		{
			con = dstSetup.getDBConnectionFromPool();
			
			
			AddressRangeManager manager = new AddressRangeManager( con, IPN_MID );
			List<AddressRange> addresses = null;
			for (Contract  contract : contracts )
			{
				
				UserGateRule ugr = new UserGateRule();
		        ugr.setContractID( contract.getID() );
		        ugr.setRuleTypeId( 1 );
		        
		        
		        addresses = manager.getContractAddressRange(contract.getID(), new GregorianCalendar(), -1 );
		        String rule = "";
		        for ( int i = 0; i < addresses.size(); i++)
		        {
		        	if ( i  > 0 )
		        	{
		        		rule += ",";	
		        	}
		        	AddressRange range = addresses.get( i );
		        	//   , .       
		        	rule += range.getAddr1();
		        		
		        }	
		        ugr.setRuleText( rule );
		        ugr.setGateID( 1 );

		        new UserGateRuleManager( con, IPN_MID ).updateUserGateRule( "new", ugr );				

			}
		}
		finally
		{
			dstSetup.returnConToPool( con );
		}
		
					
		
	}	

	
	private static Map<Integer, Map > dropTable( String tableName ) throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
										

			con = sourceSetup.getDBConnectionFromPool();
			Date time = new Date (); 
			
			
			String query = " DROP TABLE " + tableName; 
						
			con.createStatement().executeUpdate( query );
			
		}
		catch( Exception ex)
		{
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;	
	}
		
	private static Map<Integer, Map > copyTables() throws SQLException, UnsupportedEncodingException
	{
		Map<Integer, Map > users = new HashMap<Integer, Map>();
		Connection con = null;
		try
		{
										
				
			con = sourceSetup.getDBConnectionFromPool();
			Date time = new Date (); 
			
			//contract
			String tableName = "balans_copy"; // + CommonTimeUtils.format( time, "yyyy_MM_dd_HH_mm" );
			dropTable( tableName );
			
			String query = " CREATE TABLE " + tableName; 
			query +="( id BIGSERIAL UNIQUE NOT NULL,";
			query +=" balans NUMERIC(70,40) NOT NULL)";
			
			
			con.createStatement().executeUpdate( query );
			
			query = " INSERT INTO " +  tableName; 
			query +=" Select user_id, balans from balans";
			
			con.createStatement().executeUpdate( query );			
			
			//groups
			tableName = "group_balans_copy";// + CommonTimeUtils.format( time, "yyyy_MM_dd_HH_mm" );
			dropTable( tableName );
			
			query = " CREATE TABLE " + tableName; 
			query +="( id BIGSERIAL UNIQUE NOT NULL,";
			query +="balans NUMERIC(70,40) NOT NULL DEFAULT 0)";
			
			
			con.createStatement().executeUpdate( query );
			
			query = " INSERT INTO " +  tableName; 
			query +=" Select id, balans from groups";
			
			con.createStatement().executeUpdate( query );			
						
			
		}
		finally
		{
			sourceSetup.returnConToPool( con );
		}
		
		return users;	
	}
	
	
	public static void main( String[] args )
	{
		
		try
        {		
						
			sourceSetup.setValue( "db.driver", "org.postgresql.Driver" );            								
			//sourceSetup.setValue( "db.url", "jdbc:postgresql://89.107.85.45/ulogd?" );
			sourceSetup.setValue( "db.url", "jdbc:postgresql://10.4.1.251/ulogd" );
			sourceSetup.setValue( "db.user", "postgres" );
			sourceSetup.setValue( "db.pswd", "" );
			
			
			sourceSetup.initConnectionPool();
						
			
			System.out.println(" reading data...");
			
			
			Map<Integer, Map > groups = getGroups();
	        	 
			Map<Integer, Map > users = getUsers();
			Map<Integer, Map > userData = readUserData();
			Map<Integer, Map > orgData = readOrgData();
			Map<Integer, Map > balance = readBalans();
			Map<Integer, List > tariffData = readTariffUserData();
			Map<Integer, List > ipData = readIpUserData();
			
			System.out.println("backuping data...");
			
			copyTables();
			
			System.out.println("combining  data...");
			
			combineMaps( users, userData );
			combineMaps( users, orgData );
			combineMaps( users, balance );
			
			
	    	
			System.out.println(" group count = " + groups.size());
			System.out.println(" user count = " + users.size());
	    	
	    	
	    	
	    	
	    	System.out.println( " removing contracts...");
	    	ConvertUtil.removeContracts(GROUP, dstSetup );
	    	

	    	System.out.println( " importing group contact..");
	    	
	    	
	    	List <Contract> groupContacts = createGroups( groups );
	    	
	    	System.out.println( " importing contracts..");
	    	List <Contract> contracts =  createContacts( users );
	    	
	    	System.out.println( " creating  group info...");
	    	addUsersToGroups( users, groups, contracts, groupContacts );
	    	
	    	
	    	System.out.println( " creating tariff info...");
	    	
	    	addTariffInfo( users, tariffData );
	    	
	    	System.out.println( " creating ip info...");
	    	addIpData( users, ipData );
	    	
	    	
	    	users.clear();
	    	userData.clear();
	    	orgData.clear();
	    	balance.clear();
	    	tariffData.clear();
	    	ipData.clear();
	    	
	    	users = null;
	    	userData = null;
	    	orgData = null;
	    	balance = null;
	    	tariffData = null;
	    	ipData = null;
	    	
	    	System.out.println( " running gc.... ");
	    	System.gc();
	    	System.gc();
	    	System.gc();
	    	System.gc();

	    	System.out.println( " creating gate info...");
	    	addGateData( contracts );
	    	
	    	System.out.println( "ok" );
	        	
			
	        
        }
		
	 	catch (Exception ex)
        {
        	ex.printStackTrace();
        }		
		
	}	
}
