package bitel.billing.test.convert;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bitel.billing.common.CommonTimeUtils;
import bitel.billing.common.CommonUtils;
import bitel.billing.common.KernelConst;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.contract.bean.ContractService;
import bitel.billing.server.contract.bean.ContractServiceManager;
import bitel.billing.server.contract.bean.ContractStatus;
import bitel.billing.server.contract.bean.ContractStatusManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.DefaultServerSetup;
import bitel.billing.server.util.TimeUtils;

public class TelenetTV
{
	private static DefaultServerSetup bgSetup = null;
	
	private static int GROUP_ID = 1;
	private static int PATTERN = 1;
	private static int CITY_ID = 1;
	private static int PAY_SERVICE = 1;
	
	
	private static int USER_ID = 1;
	/*private static int AREA_ID = 1;
	private static int QUARTE_ID = 1;*/
	
	private static int FIO_PID = 1;
	private static int PHONE_PID = 2;
	private static int ADDRESS_PID = 3;
	private static int ADDRESS_RAW_PID = 4;
	
	
	//, 188-55
	private static String template1 = 	"^(.+),(\\s*)(\\d+)([^\\d\\s]?\\S*)-(.*)$";										
	
	/*//, 142/15-90  //, 67/135-97
	private static String template1_1 = "^(.+),(\\s*)(\\d+)/(\\S+)-(\\d+)$";				
	//, 350-27		
	private static String template2 = "^(.+),(\\s*)(\\d+)(\\S+)-(\\d+)$";
	//, 320-26/27
	private static String template3 = "^(.+),(\\s*)(\\d+)-(\\d+)/(\\S+)$";
	//, 20-111
	private static String template4 = "^(.+),(\\s*)(\\d+)-(\\d+)(\\S+)$";
	// , -121
	private static String template5 = "^(.+),(\\s*)-(\\d+)$";
	//, 4-
	private static String template6 = "^(.+),(\\s*)(\\d+)-$";
	//-, 210/1-210/1
	private static String template7 = "^(.+),(\\s*)(\\d+)/(\\S+)-(\\d+)/(\\S+)$";	
	//, 8-8
	private static String template8 = "^(.+),(\\s*)(\\d+)(\\S+)-(\\d+)(\\S+)$";
	//, 122-
	private static String template9 = "^(.+),(\\s*)(\\d+)-(.+)$";
	
	*/
	private static Pattern pattern1 = Pattern.compile( template1 );
	/*private static Pattern pattern1_1 = Pattern.compile( template1_1 );
	private static Pattern pattern2 = Pattern.compile( template2 );	
	private static Pattern pattern3 = Pattern.compile( template3 );
	private static Pattern pattern4 = Pattern.compile( template4 );
	private static Pattern pattern5 = Pattern.compile( template5 );
	private static Pattern pattern6 = Pattern.compile( template6 );
	private static Pattern pattern7 = Pattern.compile( template7 );
	private static Pattern pattern8 = Pattern.compile( template8 );
	private static Pattern pattern9 = Pattern.compile( template9 );
	*/
	
	
	
	
	
	
	private static void createContacts( List<Map> users )
	{
		
		
		Connection con = null;
		Date currDate = new Date();
		
		
		try
		{
			con = bgSetup.getDBConnection();
			
			ContractManager manager =  new ContractManager( con );
			
			System.out.println( users.size() + " users was found..");		
			
			int idx = 0;
			Map<String, Integer > billingTarifMap = ConvertUtil.getBillingTariffMap( bgSetup );
			Map<String, Integer > streetMap = ConvertUtil.getBillingStreetMap ( bgSetup );
			Map<Integer, Map<String, Integer> >  houseMap = geHouseMap( bgSetup ); 
			
			for ( Map<String, String> map : users)
			{				
	    		
	    		String number = map.get( "number" );
	    		Date startDate =  parseDate( map.get( "date_contract" ) );
	    		
	    		Contract contract = manager.createFromPattern( PATTERN, number, CommonTimeUtils.convertDateToCalendar( startDate ), "");
	    		
	    		
	    		if (contract != null)
	    		{	
	    			int cid = contract.getID();
	    			
					updateContactInfo( cid, map);			
					updateContactBalance( cid, map, currDate );
					updateTarifs( cid, map, billingTarifMap );
					updateContactParams( cid, map );
					updateAddress(cid, map, streetMap, houseMap ); 
					updateStatus( cid, map );
					updateNpayService ( cid , map );
					
	    		}
	    		
	    		
	    		        		
	    	}			
			
			System.out.println( " contracts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			ConvertUtil.closeConnection( con );
		}		
		
	}		
	private static void updateNpayService( int cid, Map<String, String> map )
	{
		
		Connection con = null;
		
		try
		{
			
			 
			con = bgSetup.getDBConnectionFromPool();
			
			Date date =  parseDate( map.get( "date_connect" ) );
			
			if ( date  == null)
			{				
				return;
			}
			 			
			
			ContractServiceManager serviceManager = new ContractServiceManager( con );
			
			
			//
			ContractService cs = new ContractService();
			cs.setContractID( cid );
			cs.setServiceID( PAY_SERVICE );
			cs.setDate1( TimeUtils.convertDateToCalendar( date ) );
			cs.setComment( " " );
			
					

			serviceManager.updateContractService( "new", cs );					
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
			
		
		
		
	}
	private static Date parseDate( String date)
	{
		if ( CommonUtils.isEmptyString( date ))
		{
			return null;
		}
		
		Date result = CommonTimeUtils.parseDate(date, "dd.MM.yyyy" );
		return result;
	}
	
	private static void updateContactInfo( int cid, Map<String, String> map )
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			String fio = map.get( "fio" );
			String dateDiscon = map.get( "date_disconnect" );
			
			
			String query = "UPDATE contract SET gr=gr| ?,  " +						
						" comment = ? " +
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP_ID );			
			ps.setString( idx++, fio );
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
	}	
	
	private static void updateStatus( int cid, Map<String, String> map )
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			
			Date dateDiscon = parseDate( map.get( "date_disconnect" ) );
			String reason  = "";
			Date dateEnd = parseDate( map.get( "date_end" ) );
			
			Date date = null;
			int statusId = -1;
			
			if ( dateEnd != null  )
			{
				statusId = KernelConst.CONTRACT_STATUS_CLOSED;
				date = dateEnd;
				reason  = map.get( "reason" );
			}
			else if ( dateDiscon != null )
			{
				statusId = KernelConst.CONTRACT_STATUS_SUSPENDED;
				date = dateDiscon;
			}
			 
			
			if (date != null)
			{
				ContractStatus status = new ContractStatus();
		        status.setContractId( cid );
		        status.setUserId( USER_ID );
		        status.setStatus( statusId );
		        status.setDate1( TimeUtils.convertDateToCalendar( date )  );
		        status.setDate2( null );
		        status.setComment( reason );
	
		        ContractStatusManager statusManager = new ContractStatusManager( con );
		        statusManager.changeStatus( status.clone() );	
			}
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
	}		
	private static void updateContactBalance(	int cid,
	                                         	Map<String, String> map, 
	                                         	Date currDate)
	{
		
		Calendar cal = new GregorianCalendar();
		cal.setTime( currDate );
		
		int year = cal.get( Calendar.YEAR );
		int month = cal.get( Calendar.MONTH  ) + 1;
		Connection con = null;;
		
		String balance = map.get( "balance" );
		if ( CommonUtils.isEmptyString( balance ) )
		{
			return;
		}
		
		try
		{	con = bgSetup.getDBConnectionFromPool();
		
			String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
			PreparedStatement ps =  con.prepareStatement( query );
			int idx = 1;
			ps.setInt( idx++, year );
			ps.setInt( idx++, month );
			ps.setInt( idx++, cid );
			ps.setDouble( idx++, Double.valueOf( balance )  );
			
			ps.executeUpdate();
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}		
		
	}
	
	private static void updateTarifs(	int cid,										
	                                 	Map<String, String> map,
	                                 	Map<String, Integer > billingTarifMap)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			
		    
		    
		    String number  = map.get( "number" );
		    
		    String tarifName = map.get( "tariff" );
		    tarifName = tarifName.trim(); 
		    tarifName = tarifName.toLowerCase();
		    
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	//System.out.println("error: tarif is empty for user " + number);
		    	return;
		    }
		    		    
		    
		    Integer tpid = billingTarifMap.get( tarifName );
		    Date dateCon =  parseDate( map.get( "date_connect" ) );
	    	if ( tpid != null)
	    	{
	    		
	    		String query = "INSERT INTO contract_tariff( cid, tpid, date1) VALUES ( ?, ?, ?)";
			    PreparedStatement ps =  con.prepareStatement(   query );
			    
			    ps.setInt( 1, cid );			    
	    		ps.setInt( 2, tpid );
	    		ps.setDate ( 3, TimeUtils.convertDateToSqlDate( dateCon ) );
	    		ps.executeUpdate();
	    		
	    	}
	    	else
	    	{
	    		System.out.println( "tariff not found(" +  number + "):" + tarifName );
	    		/*tpid = ConvertUtil.addNewTariff( con,  tarifName);
	    		System.out.println("New Tariff was added:" + tarifName);
	    		billingTarifMap.put( tarifName, tpid );*/
	    	}
	        
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
	}
	
	private static void updateAddress(	int cid,										
	                                 	Map<String, String> map,
	                                 	Map<String, Integer > streetMap,
	                                 	Map<Integer, Map<String, Integer> >  houseMap)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			String address = map.get( "address" );
			String number = map.get( "number" );
			address = address.trim();
			
			if ( CommonUtils.isEmptyString(  address ) || address.equals( ", -" ))
			{
				return;
			}
			
			//-, 267-51
		
			
			String street = "";
			String house = "";
			String flat = "";
			String frac = "";
			String comment ="";
			
			Integer streetId = -1;			
			
			Matcher m = null;
		
			
			
			if( (m = pattern1.matcher( address )).find() )
			{
				street =   m.group( 1 );
				house = m.group( 3 );
				frac = m.group( 4 );
				flat = m.group( 5 );
			}
			else  
			{
				
				System.out.println( " Unknown address format(" + number +"):"  + address); 		
				return;
				
				/*if ( (m = pattern1_1.matcher( address )).find() || (m = pattern2.matcher( address )).find() )
				{
					// , 408-29
					street =   m.group( 1 );
					house = m.group( 3 );
					frac = m.group( 4 );
					flat = m.group( 5 );					
				}
				else
				{				
					
					if ( (m = pattern3.matcher( address )).find() || (m = pattern4.matcher( address )).find() )
					{
						street =   m.group( 1 );
						house = m.group( 3 );						
						flat = m.group( 4 );
						frac = m.group( 5 );
					}
					else
					{
						if ( (m = pattern5.matcher( address )).find() || (m = pattern6.matcher( address )).find()  )
						{
							street =   m.group( 1 );
							house = m.group( 3 );																						
						}
						else
						{
							if ( ( (m = pattern7.matcher( address )).find() || (m = pattern8.matcher( address )).find() ) &&
									m.group(3).equals( m.group(5) ) &&
									m.group(4).equals( m.group(6) ) )
							{															
								street =   m.group( 1 );
								house = m.group( 3 );								
								flat = m.group( 5 );																	
							}	
							else
							{

								if ( (m = pattern9.matcher( address )).find() )
								{															
									street =   m.group( 1 );
									house = m.group( 3 );								
									comment = m.group( 4 );																	
								}																	
							
								else 
								{
								
									System.out.println( " Unknown address format(" + number +"):"  + address); 		
									return;
								}
							}						
						}	
					}
				}
				*/
			}
			if (CommonUtils.isEmptyString( street ) ||  CommonUtils.isEmptyString( house ) )
			{
				System.out.println( " Unknown address format(" + number +"):"  + address);
				return;
			}
			
			if ( !CommonUtils.isEmptyString( flat ) && flat.length() > 10 )
			{
				System.out.println( " flat length > 10 (" + number +"):"  + address);
				return;
			}
			
			
			if (frac != null)
			{
				frac = frac.toUpperCase();
			}
						
			
			streetId = streetMap.get( street );
			
			if ( streetId == null)
			{			
				String query = "INSERT into address_street(title) VALUES(?) ";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setString( 1, street );								
				ps.executeUpdate();
				streetId = ConvertUtil.lastInsertId( con );
				streetMap.put( street, streetId );
			}
			Map<String, Integer> houses = houseMap.get( streetId ); 
			if ( houses == null )
			{
				houses = new HashMap<String, Integer>();
				
				houseMap.put( streetId, houses );
			}
			String key =  getHouseKey( Integer.valueOf( house), frac );
			if ( houses.get( key ) == null )
			{
				
				String query = "INSERT INTO address_house " + "( cityid,  areaid, quarterid, streetid,"
				   + " house, frac, box_index, amount, comment, dt) " + "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setInt( 1, CITY_ID );
				ps.setInt( 2, 0 );
				ps.setInt( 3, 0 );
				ps.setInt( 4, streetId );
				ps.setInt( 5, Integer.valueOf( house) );
				ps.setString( 6, frac );
				ps.setString( 7, "" );
				ps.setInt( 8, 0 );
				ps.setString( 9, "" );
				ps.setDate( 10, TimeUtils.convertDateToSQL( new  Date() ) );
				ps.executeUpdate();		
				int houseId = ConvertUtil.lastInsertId( con );
				houses.put( key, houseId );
			}
			
			int houseId =  houses.get( key );
			
			String addressFormat = "(${index})(, ${city})(, ${area})(, ${quarter})(, . ${street})(, . ${house})(, . ${frac})(, . ${flat})( ${room})(, ${pod} .)(, ${floor} .)";
			
			String addressFull = ConvertUtil.getAddress( "", "", "", "", street, house, frac, flat, "", "", "", "", addressFormat );
			
			String query = "INSERT INTO contract_parameter_type_2 " +
			"( cid, pid, hid, flat,  pod, floor, address, comment, room) " +
			"VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ? )";
			PreparedStatement ps =  con.prepareStatement(   query );
			ps.setInt( 1, cid );
			ps.setInt( 2, ADDRESS_PID );
			ps.setInt( 3, houseId );
			ps.setString( 4, flat );
			ps.setInt( 5, -1 );
			ps.setInt( 6, -1 );
			ps.setString( 7, addressFull );
			ps.setString( 8, comment );
			ps.setString( 9, "" );
			ps.executeUpdate();		   
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
		
	}	
	
	
	
	public  static Map<Integer, Map<String, Integer> >  geHouseMap( DefaultServerSetup setup )
	{
		Map<Integer, Map<String, Integer> > result = new HashMap<Integer, Map<String, Integer> >();
		Connection con = null;
		try
		{
			con = setup.getDBConnectionFromPool();
			
			String query = "SELECT streetid, house, id, frac FROM address_house";
			
			
			PreparedStatement ps =  con.prepareStatement(   query );            
			ResultSet rs = ps.executeQuery();
			while ( rs.next() )
			{
				int steetId = rs.getInt( 1 );
				int house = rs.getInt( 2 );
				int houseId = rs.getInt( 3 );
				String frac = rs.getString( 4 );
				
				
				Map<String,Integer> houses = result.get( steetId );
				if ( houses == null)
				{
					houses = new HashMap<String, Integer>();
					result.put( steetId, houses );
				}
				houses.put ( getHouseKey( house, frac ) , houseId );
				
			}
			rs.close();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			setup.returnConToPool( con );
		}
		
		
		return result; 
	}
	private static String getHouseKey( int house, String frac )
	{
		String result  = String.valueOf( house );
		
		if ( !CommonUtils.isEmptyString( frac ))
		{
			result += "##" + frac;
		}
		
		return result;
	}		
	
	private static void updateContactParams(	int cid, Map<String, String> map)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();			
			
			ConvertUtil.addContactParamString( cid, con, map.get( "fio" ), FIO_PID );	
			ConvertUtil.addContactParamString( cid, con, map.get( "phone" ), PHONE_PID );
			ConvertUtil.addContactParamString( cid, con, map.get( "address" ), ADDRESS_RAW_PID );
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}	
		
		
		
		
		
		
	}
	
	
	
	public static List< Map >  loadData( String filePath) throws IOException
	{
		List< Map > result = new ArrayList<Map>();
		
		
		InputStream stream  = new FileInputStream( filePath  );
		
		
		
		
		int count = 1;
		byte buff [] = new byte[1000];
		
		StringBuffer strBuffer = new StringBuffer();
		
		
		while ( ( count = stream.read( buff, 0, 1000  ) )  > 0)
		{
			String line = new String ( buff, 0, count, "cp1251" );
			strBuffer.append( line );
		}
		
		String lines [] = strBuffer.toString().split( "\n" );
		
		
		for ( int i = 7 ; i < lines.length; i++)
		{
			String  line =  lines[i];
			Map map = new HashMap();
			String words [] = line.split( "\t" );
			
			int idx = 0;
			if ( words.length < 13)
			{
				System.out.println( "wrong line:" + line );
				continue;
			}
			//map.put( "hz", words [idx++] );
			map.put( "fio", words [idx++] );
			map.put( "number",  words [idx++]  );			
			map.put( "address",  words[idx++] );
			map.put( "tariff",  words[idx++] );
			map.put( "date_contract",  words[idx++] );
			map.put( "date_connect",  words[idx++] );
			map.put( "date_disconnect",  words[idx++] );
			map.put( "phone",  words[idx++] );
			map.put( "ended",  words[idx++] );
			map.put( "date_end",  words[idx++] );
			map.put( "reason",  words[idx++] );
			map.put( "disconnected",  words[idx++] );
			map.put( "balance",  words[idx++] );
			
			
			/*idx = 0;
			System.out.print("fio = " + words [idx++]);
			System.out.print(" number = " + words [idx++]);
			System.out.print(" address = " + words [idx++]);
			System.out.print(" tariff = " + words [idx++]);
			System.out.print(" date_contract = " + words [idx++]);
			System.out.print(" date_connect = " + words [idx++]);
			System.out.print(" date_disconnect = " + words [idx++]);
			System.out.print(" phone = " + words [idx++]);
			System.out.print(" ended = " + words [idx++]);
			System.out.print(" date_end = " + words [idx++]);
			System.out.print(" reason = " + words [idx++]);
			System.out.print(" disconnected = " + words [idx++]);
			System.out.print(" balance = " + words [idx++]);
			System.out.println("\n");
			*/
			
			
			
		
			
			result.add( map ); 			
			
		}
		
		
		return result;
	}
			
	
	
	public static void main( String[] args )
	{
		try
		{
			long start =  System.currentTimeMillis(); 
			bgSetup = new DefaultServerSetup();
			bgSetup.setValue( "db.driver", "com.mysql.jdbc.Driver" );            								
			bgSetup.setValue( "db.url", "jdbc:mysql://127.0.0.1/bgbilling?useUnicode=true&characterEncoding=Cp1251&allowUrlInLocalInfile=true&zeroDateTimeBehavior=convertToNull&jdbcCompliantTruncation=false" );


			bgSetup.setValue( "db.user", "bill" );
			bgSetup.setValue( "db.pswd", "bgbilling" );
			bgSetup.initConnectionPool();
			
			System.out.println("deleting contracts...");
			
			EventProcessor.initProcessor( bgSetup, false );
			
			ConvertUtil.removeContracts( GROUP_ID, bgSetup);			
			
			
			System.gc();
			System.gc();
			System.gc();
			System.gc();
			List< Map > users =  loadData( args [0] );
			System.gc();
			System.gc();
			System.gc();
			System.gc();			
			createContacts(  users );
			
			
			Calendar time2 = new GregorianCalendar();
			
			System.out.print( "time:");
			long diff =  System.currentTimeMillis() - start ;
			System.out.println( "diff=" + diff);
			System.out.println( "delta = " + TimeUtils.formatDeltaTime( diff / 1000l ) );
			
			
			
			System.out.println("ok");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
			

	}

}
